#include <stdint.h>
#include <Python.h>

#include "PyAPITests.h"

uint32_t printTests(uint32_t testInt32) {

	PyObject *newList = PyList_New(0);

	PyObject *newDict = PyDict_New();


	uint32_t y=0;

	for (uint32_t x=0;x<testInt32;x++) {
		printf("TestIteration: %u \n", x);

		printf( "tp_name for List: %s \n", (((PyObject*)(newList))->ob_type)->tp_name);
		printf( "tp_name for Dict: %s \n", (((PyObject*)(newDict))->ob_type)->tp_name);

		printf("PyType_GetFlags for List: %lu \n", PyType_GetFlags(Py_TYPE(newList)));
		printf("PyType_GetFlags for Dict: %lu \n", PyType_GetFlags(Py_TYPE(newDict)));


		printf("PyList_Size: %i \n", PyList_Size(newList));
		printf("PyDict_Size: %i \n", PyDict_Size(newDict));

		printf("PyMapping_Check for List: %i \n", PyMapping_Check(newList));
		printf("PyMapping_Check for Dict: %i \n", PyMapping_Check(newDict));

		printf("PyList_Check: %i \n", PyList_Check(newList));
		printf("PyDict_Check: %i \n", PyDict_Check(newDict));

		PyList_Append(newList, PyLong_FromUnsignedLong(x+10));
		PyDict_SetItem(newDict, PyLong_FromUnsignedLong(x), PyLong_FromUnsignedLong(x+10));

		printf("Iterators test for Dict:\n");

		PyObject *key, *value;
		Py_ssize_t pos = 0;

		while (PyDict_Next(newDict, &pos, &key, &value)) {
			printf("Key: %lu, VALUE: %lu \n", PyLong_AsUnsignedLong(key), PyLong_AsUnsignedLong(value));
		}
		printf("\nEnd iterators test.\n");
		y++;

		printf("-----------------\n");

	}

	fflush(stdout);

	return y;
}

